列出用户的直接成员身份
本文内容
命名空间:microsoft.graph
获取用户直接所属的组 ,目录角色 和管理单位 。 此操作不可传递。 要通过传递成员身份检索用户所属的组、目录角色和管理单元,请使用 列出用户可传递成员所属 API。
权限
要调用此 API,需要以下权限之一。要了解详细信息,包括如何选择权限的信息,请参阅权限 。
权限类型
权限(从最低特权到最高特权)
委派(工作或学校帐户)
User.Read、GroupMember.Read.All、Directory.Read.All、Directory.ReadWrite.All
委派(个人 Microsoft 帐户)
不支持。
应用程序
Directory.Read.All、Directory.ReadWrite.All
注意: 若要列出具有隐藏成员身份的组成员,需要 Member.Read.Hidden 权限。
当应用程序查询返回 directoryObject 类型集合的关系时,如果它没有读取某种派生类型(如设备)的权限,则会返回该类型的成员,但返回的信息有限。 使用这种行为,应用程序可请求所需的最低特权权限,而不依赖于 Directory. * 集权限。 有关详细信息,请参阅为不可访问的成员对象返回有限的信息 。
HTTP 请求
GET /me/memberOf
GET /users/{id | userPrincipalName}/memberOf
可选的查询参数
此方法支持OData query parameters 以帮助自定义响应,包括 $search、$count、 和 $filter 还启用了 OData 强制转换,例如,你可以强制转换为仅获取用户所属的 directoryRoles。 $search可以用在 displayName 属性。 为该资源添加或更新项目时,将对它们进行专门索引,以便与 $count 和 $search 查询参数一起使用。 在添加或更新项目与在索引中可用之间可能会稍有延迟。
标头
值
Authorization
Bearer {token}。必需。
ConsistencyLevel
最终。 使用 $search、$filter、$orderby 或 OData 强制转换查询参数时,此标头和 $count 是必需的。 它使用的索引可能与对象的最新更改不同步。
请求正文
请勿提供此方法的请求正文。
响应
如果成功,此方法在响应正文中返回 200 OK 响应代码和 directoryObject 对象集合。
示例
示例 1:获取用户是其直接成员的组、目录角色和管理单元
请求
下面展示了示例请求。
GET https://graph.microsoft.com/v1.0/users/{id}/memberOf
GraphServiceClient graphClient = new GraphServiceClient( authProvider );
var memberOf = await graphClient.Users["{user-id}"].MemberOf
.Request()
.GetAsync();
GraphServiceClient graphClient = new GraphServiceClient( authProvider );
var memberOf = await graphClient.Users["{user-id}"].MemberOf
.Request()
.GetAsync();
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
const options = {
authProvider,
};
const client = Client.init(options);
let memberOf = await client.api('/users/{id}/memberOf')
.get();
const options = {
authProvider,
};
const client = Client.init(options);
let memberOf = await client.api('/users/{id}/memberOf')
.get();
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
MSHTTPClient *httpClient = [MSClientFactory createHTTPClientWithAuthenticationProvider:authenticationProvider];
NSString *MSGraphBaseURL = @"https://graph.microsoft.com/v1.0/";
NSMutableURLRequest *urlRequest = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:[MSGraphBaseURL stringByAppendingString:@"/users/{id}/memberOf"]]];
[urlRequest setHTTPMethod:@"GET"];
MSURLSessionDataTask *meDataTask = [httpClient dataTaskWithRequest:urlRequest
completionHandler: ^(NSData *data, NSURLResponse *response, NSError *nserror) {
NSError *jsonError = nil;
MSCollection *collection = [[MSCollection alloc] initWithData:data error:&jsonError];
MSGraphDirectoryObject *directoryObject = [[MSGraphDirectoryObject alloc] initWithDictionary:[[collection value] objectAtIndex: 0] error:&nserror];
}];
[meDataTask execute];
MSHTTPClient *httpClient = [MSClientFactory createHTTPClientWithAuthenticationProvider:authenticationProvider];
NSString *MSGraphBaseURL = @"https://graph.microsoft.com/v1.0/";
NSMutableURLRequest *urlRequest = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:[MSGraphBaseURL stringByAppendingString:@"/users/{id}/memberOf"]]];
[urlRequest setHTTPMethod:@"GET"];
MSURLSessionDataTask *meDataTask = [httpClient dataTaskWithRequest:urlRequest
completionHandler: ^(NSData *data, NSURLResponse *response, NSError *nserror) {
NSError *jsonError = nil;
MSCollection *collection = [[MSCollection alloc] initWithData:data error:&jsonError];
MSGraphDirectoryObject *directoryObject = [[MSGraphDirectoryObject alloc] initWithDictionary:[[collection value] objectAtIndex: 0] error:&nserror];
}];
[meDataTask execute];
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
GraphServiceClient graphClient = GraphServiceClient.builder().authenticationProvider( authProvider ).buildClient();
DirectoryObjectCollectionWithReferencesPage memberOf = graphClient.users("{id}").memberOf()
.buildRequest()
.get();
GraphServiceClient graphClient = GraphServiceClient.builder().authenticationProvider( authProvider ).buildClient();
DirectoryObjectCollectionWithReferencesPage memberOf = graphClient.users("{id}").memberOf()
.buildRequest()
.get();
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
//THE GO SDK IS IN PREVIEW. NON-PRODUCTION USE ONLY
graphClient := msgraphsdk.NewGraphServiceClient(requestAdapter)
userId := "user-id"
result, err := graphClient.UsersById(&userId).MemberOf().Get()
//THE GO SDK IS IN PREVIEW. NON-PRODUCTION USE ONLY
graphClient := msgraphsdk.NewGraphServiceClient(requestAdapter)
userId := "user-id"
result, err := graphClient.UsersById(&userId).MemberOf().Get()
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
Import-Module Microsoft.Graph.Users
Get-MgUserMemberOf -UserId $userId
Import-Module Microsoft.Graph.Users
Get-MgUserMemberOf -UserId $userId
有关如何将 SDK 添加 到项目并 创建 authProvider 实例的 详细信息,请参阅 SDK 文档 。
响应
下面展示了示例响应。
注意: 为了提高可读性,可能缩短了此处显示的响应对象。
HTTP/1.1 200 OK
Content-type: application/json
{
"value": [
{
"@odata.type": "#microsoft.graph.group",
"displayName": "All Users",
"mailEnabled": false,
"securityEnabled": true
}
]
}
示例 2:只获取用户是其直接成员的所有组、目录角色和管理单元的计数
请求
下面是一个请求示例。
GET https://graph.microsoft.com/v1.0/users/{id}/memberOf/$count
ConsistencyLevel: eventual
响应
下面展示了示例响应。
注意: 为了提高可读性,可能缩短了此处显示的响应对象。
HTTP/1.1 200 OK
Content-type: text/plain
17
示例 3:使用 OData 强制转换以仅获取组成员身份的计数
请求
下面展示了示例请求。
GET https://graph.microsoft.com/v1.0/users/{id}/memberOf/microsoft.graph.group/$count
ConsistencyLevel: eventual
响应
下面展示了示例响应。
HTTP/1.1 200 OK
Content-type: text/plain
16
示例 4:使用 $search 和 OData 强制转换来获取显示名称中包含字母“tier”(包括返回的对象数)的组的成员资格
请求
下面展示了示例请求。
GET https://graph.microsoft.com/v1.0/users/{id}/memberOf/microsoft.graph.group?$count=true&$orderby=displayName&$search="displayName:tier"&$select=displayName,id
ConsistencyLevel: eventual
响应
下面展示了示例响应。
注意: 为了提高可读性,可能缩短了此处显示的响应对象。
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context":"https://graph.microsoft.com/v1.0/$metadata#groups(displayName,id)",
"@odata.count":7,
"value":[
{
"displayName":"Contoso-tier Query Notification",
"id":"11111111-2222-3333-4444-555555555555"
}
]
}
示例 5:使用 $filter 和 OData 强制转换来获取显示名称以“a”开头(包括返回的对象数)的组
请求
下面展示了示例请求。
GET https://graph.microsoft.com/v1.0/users/{id}/memberOf/microsoft.graph.group?$count=true&$orderby=displayName&$filter=startswith(displayName, 'a')
ConsistencyLevel: eventual
响应
下面展示了示例响应。
注意: 为了提高可读性,可能缩短了此处显示的响应对象。
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context":"https://graph.microsoft.com/v1.0/$metadata#groups",
"@odata.count":76,
"value":[
{
"displayName":"AAD Contoso Users",
"mail":"AADContoso_Users@contoso.com",
"mailEnabled":true,
"mailNickname":"AADContoso_Users",
"securityEnabled":true
}
]
}